<script lang="ts">
  import { fade, fly } from 'svelte/transition';
  import { quintOut } from 'svelte/easing';
  import type { EventConfiguration } from '@models/EventConfigurations';
  import { Input } from '@sveltestrap/sveltestrap';

  export let open = false;
  export let showBackdrop = true;
  export let onClosed: () => {};
  export let onSaved: (data: EventConfiguration) => {};
  export let event: EventConfiguration;

  const modalSaved = (data: EventConfiguration) => {
    open = false;
    if (onSaved) {
      onSaved(data);
    }
  };
  const modalCancel = () => {
    if (onClosed) {
      onClosed();
    }
  };

  const format = 'DD / MM / YYYY HH:MM';
</script>

{#if open}
  <div
    class="modal"
    id="eventConfigurationModal"
    tabindex="-1"
    role="dialog"
    aria-labelledby="eventConfigurationModal"
    aria-hidden="false"
  >
    <div
      class="modal-dialog"
      role="document"
      in:fly={{ y: -50, duration: 300 }}
      out:fly={{ y: -50, duration: 300, easing: quintOut }}
    >
      <div class="modal-content">
        <div class="modal-header">
          <h2 class="modal-title" id="eventConfigurationModalTitle">
            {`Edit ${event.name}`}
          </h2>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close" on:click={() => modalCancel()}>
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <div style="display: flex; flex-direction: column; align-content: center">
            <h5>Event Active</h5>
            <input type="checkbox" bind:checked={event.active} />
            <h5>Name</h5>
            <textarea bind:value={event.name} />
            <h5>Organization Link</h5>
            <textarea bind:value={event.org_link} />
            <h5>Event Open</h5>
            <div class="form-group col-md-6">
              <Input type="datetime-local" bind:value={event.event_open} name="datetime" id="exampleDatetime" />
            </div>
            <h5>Event Start</h5>
            <div class="form-group col-md-6">
              <Input type="datetime-local" bind:value={event.start} name="datetime" id="exampleDatetime" />
            </div>
            <h5>Event End</h5>
            <div class="form-group col-md-6">
              <Input type="datetime-local" bind:value={event.end} name="datetime" id="exampleDatetime" />
            </div>
            <h5>Event Close</h5>
            <div class="form-group col-md-6">
              <Input type="datetime-local" bind:value={event.event_close} name="datetime" id="exampleDatetime" />
            </div>
            <h5>Break Start</h5>
            <div class="form-group col-md-6">
              <Input type="datetime-local" bind:value={event.break_start} name="datetime" id="exampleDatetime" />
            </div>
            <h5>Break End</h5>
            <div class="form-group col-md-6">
              <Input type="datetime-local" bind:value={event.break_end} name="datetime" id="exampleDatetime" />
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal" on:click={() => modalCancel()}
            >Close
          </button>
          <button type="button" class="btn btn-primary" on:click={() => modalSaved(event)}>Save changes </button>
        </div>
      </div>
    </div>
  </div>
  {#if showBackdrop}
    <div class="modal-backdrop show" transition:fade={{ duration: 150 }} />
  {/if}
{/if}

<style>
  .modal {
    display: block;
    overflow-y: scroll;
  }

  textarea {
    width: auto;
  }
</style>
